function varargout = PSS(varargin)
% PSS MATLAB code for PSS.fig
%      PSS, by itself, creates a new PSS or raises the existing
%      singleton*.
%
%      H = PSS returns the handle to a new PSS or the handle to
%      the existing singleton*.
%
%      PSS('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in PSS.M with the given input arguments.
%
%      PSS('Property','Value',...) creates a new PSS or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before PSS_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to PSS_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help PSS

% Last Modified by GUIDE v2.5 26-Jan-2022 18:00:29

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @PSS_OpeningFcn, ...
                   'gui_OutputFcn',  @PSS_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before PSS is made visible.
function PSS_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to PSS (see VARARGIN)

% Choose default command line output for PSS
handles.output = hObject;

PSS_mPath = which('PSS');
PSS_Path = PSS_mPath(1:end-5);
handles.MaskPath = [];
handles.Mask = 'BrainMask_05_61x73x61.img';
handles.MaskFullPath = [PSS_Path handles.Mask];
handles.CurrDir = pwd;
handles.DataDir = [];
handles.OutDir = [];
handles.Method = 'Linear';
handles.TR = 2;
handles.Low = 0.01;
handles.High = 0.25;

% Update handles structure
guidata(hObject, handles);



% MAIN FUNCTION
% --- Executes on button press in Press2Cal.
function Press2Cal_Callback(hObject, eventdata, handles)
% hObject    handle to Press2Cal (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

PSS_mainFunc(handles.DataDir, handles.OutDir, handles.MaskFullPath,...
    handles.Method, handles.TR, handles.Low, handles.High)

guidata(hObject, handles);



% --- Outputs from this function are returned to the command line.
function varargout = PSS_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;



function InputPath_Callback(hObject, eventdata, handles)
% hObject    handle to InputPath (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% --- Executes during object creation, after setting all properties.
function InputPath_CreateFcn(hObject, eventdata, handles)
% hObject    handle to InputPath (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function OutputPath_Callback(hObject, eventdata, handles)
% hObject    handle to OutputPath (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% --- Executes during object creation, after setting all properties.
function OutputPath_CreateFcn(hObject, eventdata, handles)
% hObject    handle to OutputPath (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function MaskFile_Callback(hObject, eventdata, handles)
% hObject    handle to MaskFile (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% --- Executes during object creation, after setting all properties.
function MaskFile_CreateFcn(hObject, eventdata, handles)
% hObject    handle to MaskFile (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



% --- Executes on button press in ImageInput.
function ImageInput_Callback(hObject, eventdata, handles)
% hObject    handle to ImageInput (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.DataDir = uigetdir(handles.CurrDir, 'Please select subjects functional image directory');
if handles.DataDir
    set(handles.InputPath, 'String', handles.DataDir);
end
guidata(hObject, handles);

% --- Executes on button press in ImageOutput.
function ImageOutput_Callback(hObject, eventdata, handles)
% hObject    handle to ImageOutput (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.OutDir = uigetdir(handles.CurrDir, 'Please select output directory');
if handles.OutDir
    set(handles.OutputPath, 'String', handles.OutDir);
end
guidata(hObject, handles);

% --- Executes on button press in maskfileInput.
function maskfileInput_Callback(hObject, eventdata, handles)
% hObject    handle to maskfileInput (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[handles.Mask, handles.MaskPath] = uigetfile({'*.img;*.hdr;*.nii','All Image Files';...
'*.*', 'All Files (*.*)'}, 'Please select mask file');
if handles.MaskPath
    handles.MaskFullPath = [handles.MaskPath handles.Mask];
    set(handles.MaskFile, 'String', [handles.MaskPath handles.Mask]);
end
guidata(hObject, handles);



% --- Executes on selection change in MethodName_input.
function MethodName_input_Callback(hObject, eventdata, handles)
% hObject    handle to MethodName_input (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.Method = get(handles.MethodName_input,'value');
if handles.Method == 1
    handles.Method = 'Linear';
else
    handles.Method = 'Plaw';
end
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function MethodName_input_CreateFcn(hObject, eventdata, handles)
% hObject    handle to MethodName_input (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function TR_input_Callback(hObject, eventdata, handles)
% hObject    handle to TR_input (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.TR = str2double(get(handles.TR_input,'string'));
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function TR_input_CreateFcn(hObject, eventdata, handles)
% hObject    handle to TR_input (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function LowFreq_input_Callback(hObject, eventdata, handles)
% hObject    handle to LowFreq_input (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.Low = str2double(get(handles.LowFreq_input,'string'));
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function LowFreq_input_CreateFcn(hObject, eventdata, handles)
% hObject    handle to LowFreq_input (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function HighFreq_input_Callback(hObject, eventdata, handles)
% hObject    handle to HighFreq_input (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.High = str2double(get(handles.HighFreq_input,'string'));
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function HighFreq_input_CreateFcn(hObject, eventdata, handles)
% hObject    handle to HighFreq_input (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
