function PLS_image = PSS_mainFunc(DataPath, OutPaht, Mask, Methods, TR, LowCut, HighCut)

% For loading Brain Mask.
[DataMask, HeadMask] = rp_ReadNiftiImage(Mask);

% For different methods.
if strcmp(Methods, 'Plaw')
    isLinear = 0;
else
    isLinear = 1;
end

Fs = 1/TR;

cd(DataPath)
sublist = dir(); 
% For Windows and MacOS dirlist.
if length(sublist(2).name) <= 3
    subNum = 3;
else
    if length(sublist(1).name) <= 3
        subNum = 2;
    end
end

% Calculation
for i = subNum:length(sublist)
    cd(sublist(i).name)
    Data4Dlist = dir('*.nii');
    [Data4D, Head4D] = rp_ReadNiftiImage(Data4Dlist.name);
    DataMask4D = repmat(DataMask, 1, 1, 1, size(Data4D, 4));
    Data4D_masked = Data4D.*DataMask4D;
    Data2D_Masked = reshape(Data4D_masked, [], size(Data4D, 4));
    
    dataIdx = find(Data2D_Masked(:,1)~=0);
    for j = 1:length(dataIdx)
        coefficient(j) = PSS_calc(Data2D_Masked(dataIdx(j),:)', Fs, LowCut, HighCut, isLinear);
    end
    Zcoefficient = (coefficient-mean(coefficient))./std(coefficient);
    
    DataCoef = zeros(size(Data2D_Masked,1),1);
    zDataCoef = zeros(size(Data2D_Masked,1),1);
    for p = 1:length(dataIdx)
        DataCoef(dataIdx(p)) = coefficient(p);
    end
    for q = 1:length(dataIdx)
        zDataCoef(dataIdx(q)) = Zcoefficient(q);
    end
    
    DataCoef3D = reshape(DataCoef, size(DataMask));
    zDataCoef3D = reshape(zDataCoef, size(DataMask));
    rp_WriteNiftiImage(DataCoef3D, Head4D, [OutPaht filesep Methods '_results_' sublist(i).name]);
    rp_WriteNiftiImage(zDataCoef3D, Head4D, [OutPaht filesep Methods '_zResults_' sublist(i).name]);
    disp(sublist(i).name)
    clear dataIdx
    cd ..
end

